import{s as ut,o as mt,n as pt}from"../chunks/scheduler.9039eef2.js";import{S as ht,i as xt,g as l,s as o,r as E,A as gt,h as r,f as i,c as s,j as dt,u as P,x as d,k as ft,y as Tt,a as n,v as q,d as B,t as H,w as R}from"../chunks/index.cdcc3d35.js";import{T as $t}from"../chunks/Tip.6f74db41.js";import{H as V}from"../chunks/Heading.96ce3702.js";function wt(N){let a,u='More details for checking supported tasks <a href="https://huggingface.co/docs/optimum-neuron/guides/export_model#selecting-a-task" rel="nofollow">here</a>.';return{c(){a=l("p"),a.innerHTML=u},l(c){a=r(c,"P",{"data-svelte-h":!0}),d(a)!=="svelte-hfkaug"&&(a.innerHTML=u)},m(c,M){n(c,a,M)},p:pt,d(c){c&&i(a)}}}function kt(N){let a,u,c,M,m,S,p,Z=`You can export a PyTorch model to Neuron with 🤗 Optimum to run inference on AWS <a href="https://aws.amazon.com/ec2/instance-types/inf1/" rel="nofollow">Inferntia 1</a>
and <a href="https://aws.amazon.com/ec2/instance-types/inf2/" rel="nofollow">Inferentia 2</a>.`,A,h,I,x,tt=`There is an export function for each generation of the Inferentia accelerator, <code>export_neuron</code>
for INF1 and <code>export_neuronx</code> on INF2, but you will be able to use directly the export function <code>export</code>, which will select the proper
exporting function according to the environment.`,D,g,et=`Besides, you can check if the exported model is valid via <code>validate_model_outputs</code>, which compares
the compiled model’s output on Neuron devices to the PyTorch model’s output on CPU.`,F,T,O,$,it="Exporting a PyTorch model to a Neuron compiled model involves specifying:",z,w,nt="<li>The input names.</li> <li>The output names.</li> <li>The dummy inputs used to trace the model. This is needed by the Neuron Compiler to record the computational graph and convert it to a TorchScript module.</li> <li>The compilation arguments used to control the trade-off between hardware efficiency (latency, throughput) and accuracy.</li>",X,k,at=`Depending on the choice of model and task, we represent the data above with <em>configuration classes</em>. Each configuration class is associated with
a specific model architecture, and follows the naming convention <code>ArchitectureNameNeuronConfig</code>. For instance, the configuration which specifies the Neuron
export of BERT models is <code>BertNeuronConfig</code>.`,j,v,ot="Since many architectures share similar properties for their Neuron configuration, 🤗 Optimum adopts a 3-level class hierarchy:",U,_,st=`<li>Abstract and generic base classes. These handle all the fundamental features, while being agnostic to the modality (text, image, audio, etc).</li> <li>Middle-end classes. These are aware of the modality, but multiple can exist for the same modality depending on the inputs they support.
They specify which input generators should be used for the dummy inputs, but remain model-agnostic.</li> <li>Model-specific classes like the <code>BertNeuronConfig</code> mentioned above. These are the ones actually used to export models.</li>`,G,y,W,L,lt="<thead><tr><th>Architecture</th> <th>Task</th></tr></thead> <tbody><tr><td>ALBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>BERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>BLOOM</td> <td>text-generation</td></tr> <tr><td>CamemBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>ConvBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DeBERTa (INF2 only)</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DeBERTa-v2 (INF2 only)</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>DistilBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>ELECTRA</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>FlauBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>GPT2</td> <td>text-generation</td></tr> <tr><td>Llama, Llama 2</td> <td>text-generation</td></tr> <tr><td>Mistral</td> <td>text-generation</td></tr> <tr><td>MobileBERT</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>MPNet</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>OPT</td> <td>text-generation</td></tr> <tr><td>RoBERTa</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>RoFormer</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>XLM</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>XLM-RoBERTa</td> <td>feature-extraction, fill-mask, multiple-choice, question-answering, text-classification, token-classification</td></tr> <tr><td>Stable Diffusion</td> <td>text-to-image, image-to-image, inpaint</td></tr> <tr><td>Stable Diffusion XL Base</td> <td>text-to-image, image-to-image, inpaint</td></tr> <tr><td>Stable Diffusion XL Refiner</td> <td>image-to-image, inpaint</td></tr></tbody>",Y,f,J,C,rt="More architectures coming soon, stay tuned! 🚀",K,b,Q;return m=new V({props:{title:"Inferentia Exporter",local:"inferentia-exporter",headingTag:"h1"}}),h=new V({props:{title:"Export functions",local:"export-functions",headingTag:"h2"}}),T=new V({props:{title:"Configuration classes for Neuron exports",local:"configuration-classes-for-neuron-exports",headingTag:"h2"}}),y=new V({props:{title:"Supported architectures",local:"supported-architectures",headingTag:"h2"}}),f=new $t({props:{$$slots:{default:[wt]},$$scope:{ctx:N}}}),{c(){a=l("meta"),u=o(),c=l("p"),M=o(),E(m.$$.fragment),S=o(),p=l("p"),p.innerHTML=Z,A=o(),E(h.$$.fragment),I=o(),x=l("p"),x.innerHTML=tt,D=o(),g=l("p"),g.innerHTML=et,F=o(),E(T.$$.fragment),O=o(),$=l("p"),$.textContent=it,z=o(),w=l("ol"),w.innerHTML=nt,X=o(),k=l("p"),k.innerHTML=at,j=o(),v=l("p"),v.textContent=ot,U=o(),_=l("ol"),_.innerHTML=st,G=o(),E(y.$$.fragment),W=o(),L=l("table"),L.innerHTML=lt,Y=o(),E(f.$$.fragment),J=o(),C=l("p"),C.textContent=rt,K=o(),b=l("p"),this.h()},l(t){const e=gt("svelte-u9bgzb",document.head);a=r(e,"META",{name:!0,content:!0}),e.forEach(i),u=s(t),c=r(t,"P",{}),dt(c).forEach(i),M=s(t),P(m.$$.fragment,t),S=s(t),p=r(t,"P",{"data-svelte-h":!0}),d(p)!=="svelte-5i12yp"&&(p.innerHTML=Z),A=s(t),P(h.$$.fragment,t),I=s(t),x=r(t,"P",{"data-svelte-h":!0}),d(x)!=="svelte-1djz5bf"&&(x.innerHTML=tt),D=s(t),g=r(t,"P",{"data-svelte-h":!0}),d(g)!=="svelte-zk3hwe"&&(g.innerHTML=et),F=s(t),P(T.$$.fragment,t),O=s(t),$=r(t,"P",{"data-svelte-h":!0}),d($)!=="svelte-15gsxx7"&&($.textContent=it),z=s(t),w=r(t,"OL",{"data-svelte-h":!0}),d(w)!=="svelte-lhsb7m"&&(w.innerHTML=nt),X=s(t),k=r(t,"P",{"data-svelte-h":!0}),d(k)!=="svelte-1hhqq53"&&(k.innerHTML=at),j=s(t),v=r(t,"P",{"data-svelte-h":!0}),d(v)!=="svelte-tqmfwt"&&(v.textContent=ot),U=s(t),_=r(t,"OL",{"data-svelte-h":!0}),d(_)!=="svelte-1ea686j"&&(_.innerHTML=st),G=s(t),P(y.$$.fragment,t),W=s(t),L=r(t,"TABLE",{"data-svelte-h":!0}),d(L)!=="svelte-qsccg0"&&(L.innerHTML=lt),Y=s(t),P(f.$$.fragment,t),J=s(t),C=r(t,"P",{"data-svelte-h":!0}),d(C)!=="svelte-dm8pu8"&&(C.textContent=rt),K=s(t),b=r(t,"P",{}),dt(b).forEach(i),this.h()},h(){ft(a,"name","hf:doc:metadata"),ft(a,"content",vt)},m(t,e){Tt(document.head,a),n(t,u,e),n(t,c,e),n(t,M,e),q(m,t,e),n(t,S,e),n(t,p,e),n(t,A,e),q(h,t,e),n(t,I,e),n(t,x,e),n(t,D,e),n(t,g,e),n(t,F,e),q(T,t,e),n(t,O,e),n(t,$,e),n(t,z,e),n(t,w,e),n(t,X,e),n(t,k,e),n(t,j,e),n(t,v,e),n(t,U,e),n(t,_,e),n(t,G,e),q(y,t,e),n(t,W,e),n(t,L,e),n(t,Y,e),q(f,t,e),n(t,J,e),n(t,C,e),n(t,K,e),n(t,b,e),Q=!0},p(t,[e]){const ct={};e&2&&(ct.$$scope={dirty:e,ctx:t}),f.$set(ct)},i(t){Q||(B(m.$$.fragment,t),B(h.$$.fragment,t),B(T.$$.fragment,t),B(y.$$.fragment,t),B(f.$$.fragment,t),Q=!0)},o(t){H(m.$$.fragment,t),H(h.$$.fragment,t),H(T.$$.fragment,t),H(y.$$.fragment,t),H(f.$$.fragment,t),Q=!1},d(t){t&&(i(u),i(c),i(M),i(S),i(p),i(A),i(I),i(x),i(D),i(g),i(F),i(O),i($),i(z),i(w),i(X),i(k),i(j),i(v),i(U),i(_),i(G),i(W),i(L),i(Y),i(J),i(C),i(K),i(b)),i(a),R(m,t),R(h,t),R(T,t),R(y,t),R(f,t)}}}const vt='{"title":"Inferentia Exporter","local":"inferentia-exporter","sections":[{"title":"Export functions","local":"export-functions","sections":[],"depth":2},{"title":"Configuration classes for Neuron exports","local":"configuration-classes-for-neuron-exports","sections":[],"depth":2},{"title":"Supported architectures","local":"supported-architectures","sections":[],"depth":2}],"depth":1}';function _t(N){return mt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bt extends ht{constructor(a){super(),xt(this,a,_t,kt,ut,{})}}export{bt as component};
